//
// Fragment shader for procedural bricks
//
// Authors: Dave Baldwin, Steve Koren, Randi Rost
//          based on a shader by Darwyn Peachey
//
// Copyright (c) 2002-2004 3Dlabs Inc. Ltd.
//
// See 3Dlabs-License.txt for license information
//  

uniform vec3  BrickColor, MortarColor;
uniform vec2  BrickSize;
uniform vec2  BrickPct;
uniform int   rowNum;

varying vec2  MCposition;
varying float LightIntensity;
varying int   NormDir;

void main(void)
{
    vec3  color;
    vec2  position, useBrick;
	 vec2  delta = vec2(0.05, 0.05);
	 vec2  zero2 = vec2(0.0, 0.0);
    
    position = MCposition / BrickSize;

    if (fract(position.y * 0.5) > 0.5 && NormDir == 0)
        position.x += 0.5;

    if (fract(position.y * 0.5) <= 0.5 && NormDir == 1)
        position.x += 0.5;

	 if (position.y > rowNum || position.y < -rowNum) {
	    useBrick = zero2; // usr mortar color for top and bottom rows
	 }	 
	 else {
	 	 position = fract(position);
	    useBrick = smoothstep(position-delta, position, BrickPct) // antialias right and top edges
	  		       - smoothstep(position-delta, position, zero2); // antialias left and bottom edges
	 }				 
		 	
    color  = mix(MortarColor, BrickColor, useBrick.x * useBrick.y);
    color *= LightIntensity;
    gl_FragColor = vec4 (color, 1.0);
}
